<template>
  <div>
    <v-container>
      <v-card class="elevation-4 emailStyle">

          <div class="toolBar">
          <v-toolbar-title>
            <span class="primary--text"><b>Mala Direta</b></span>
          </v-toolbar-title>
          <v-icon small class="mx-2">mdi-chevron-double-right</v-icon>
          <v-tooltip bottom nudge-bottom color="primary">
            <template v-slot:activator="{ on }">
              <v-icon
                :style="hoverRefreshButton && 'color: #2a0845'"
                v-on="on"
                class="mr-3"
                @mouseenter="hoverRefreshButton = true"
                @mouseleave="hoverRefreshButton = false"
                @click="refresh"
                >mdi-refresh</v-icon
              >
            </template>
            <span>Atualizar</span>
          </v-tooltip>
          <div style="font-size:0.9rem" class="msgHeader">
            <a
              :style="viewAllMessages && 'font-weight: bold; color:#2a0845'"
              @click="handleShowAllMessages"
              >Todas mensagens ({{ allMsgLength }})</a
            >
            <a
              :style="viewAllMessagesNotRead && 'font-weight: bold;color:#2a0845'"
              @click="handleShowAllMessagesNotRead"
              >Mensagens não lidas ({{ showAllMessagesNotRead.length - refreshLenghtNotRead }})</a
            >
            <a
              :style="viewSentMessages && 'font-weight: bold;color:#2a0845'"
              @click="handleShowAllMessagesSent"
              >Mensagens enviadas ({{ showAllSentMessages.length }})</a
            >
          </div>
          <v-spacer />
          <div class="navDirectMessageOption">
            <v-btn small color="primary" class="mr-4" elevation="0" @click="openNewMessageDialog">
              Nova Mensagem
              <v-icon small right class="ml-3">mdi-plus</v-icon>
            </v-btn>
          </div>
        </div>

        <!-- Show msgs -->
        <v-card-text v-if="messages.length == 0 && loading == false">
          <section class="noMsg">
            <v-icon class="pr-2 pb-2" color="secondary" x-large>mdi-email-alert-outline</v-icon>
            <p v-if="!viewAllMessagesNotRead">
              Ops, você ainda <b>não possui nenhuma mensagem</b> nessa entidade.
            </p>
            <p v-else>Ops, você <b>não possui nenhuma mensagem não lida</b> nessa entidade.</p>
          </section>
        </v-card-text>
        <v-data-table
          v-if="messages.length > 0 && loading == false"
          class="elevation-1 px-12 pb-6"
          calculate-widths
          :headers="headers"
          :items="messages"
          :footer-props="{ itemsPerPageText: 'Mensagens por página' }"
          @click:row="openMsg"
        >
          <template v-slot:[`item.msgRead`]="{ item }">
            <section>
              <v-icon v-if="!item.msgRead">mdi-email</v-icon>
              <v-icon v-else>mdi-email-open-outline</v-icon>
            </section>
          </template>
          <template v-slot:[`item.data`]="{ item }">
            <section v-html="compareDate(item.data)" style="font-size: 0.8rem" />
          </template>
          <template v-slot:[`item.msg`]="{ item }">
            <section class="px-0 py-2 ma-0">
              <b>{{ item.subject }}</b>
              <!-- Show Message -->
              <span>
                <span v-if="item.msg.length > 90" class="ml-1"
                  >- {{ item.msgPreview.substring(0, 90) }}...</span
                >
                <span v-else class="ml-1">- {{ item.msgPreview }}</span>
              </span>
              <!-- End Show Message -->
              <span v-if="item.attachment.length > 0">
                <v-tooltip color="primary" bottom nudge-bottom="-5">
                  <template v-slot:activator="{ on }">
                    <v-icon v-on="on" small>mdi-paperclip</v-icon>
                  </template>
                  <span>Cheque seu email para visualizar os anexos.</span>
                </v-tooltip>
                <!-- <v-chip
                  v-for="attach in item.attachment"
                  :key="attach.id"
                  :outlined="hoverAttachment != attach.id"
                  :color="hoverAttachment == attach.id ? 'secondary' : 'primary'"
                  class="ml-1"
                  small
                  >{{ attach.name }}</v-chip
                > -->
              </span>
            </section>
          </template>
        </v-data-table>
      </v-card>
    </v-container>
    <!-- Dialogs -->
    <v-dialog
      v-model="openDialogNewMessage"
      @keydown.esc="resetDialogInfo"
      @click:outside="resetDialogInfo"
      width="800px"
    >
      <new-message @sendedMsg="refreshAfterSend" @closeDialog="closeNewMessageDialog" />
    </v-dialog>
    <v-dialog v-model="openDialogRead" width="800px">
      <read-message :message="selectedMessage" @closeMessage="closeMsg" />
    </v-dialog>
  </div>
</template>

<script>
import { mapGetters, mapState } from 'vuex'
import NewMessage from '../components/directMessage/newMessage.vue'
import ReadMessage from '../components/directMessage/readMessage.vue'

// integração backend
import { Utils } from '../utils/utils'
import DirectMessage from '../services/directMessage'

export default {
  name: 'DirectMessage',
  components: {
    NewMessage,
    ReadMessage,
  },
  data: () => ({
    loading: false,
    openDialogNewMessage: false,
    openDialogRead: false,
    hoverRow: null,
    hoverAttachment: '',
    hoverRefreshButton: false,
    headers: [
      { text: '', sortable: false, value: 'msgRead', width: '1%' },
      { text: 'Mensagem', sortable: false, value: 'msg', width: '59%' },
      { text: 'Remetente', sortable: false, value: 'sender', width: '22%' },
      { text: 'Data', sortable: false, value: 'data', width: '18%' },
    ],
    allMsgLength: 0,
    showAllMessagesNotRead: [],
    refreshLenghtNotRead: 0,
    viewAllMessagesNotRead: false,
    showAllMessages: [],
    viewAllMessages: true,
    showAllSentMessages: [],
    viewSentMessages: false,
    messages: [
      // {
      //   id: '21321',
      //   msgRead: false,
      //   sender: 'Aldair da Silva',
      //   senderEmail: 'aldairdasilva@gmail.com',
      //   senderId: '23129012',
      //   data: '03-09-20',
      //   subject: 'Titulo',
      //   msgPreview: "msg limitada até 90 caracteres",
      //   msg:
      //     '<p><b>Atenção!</b></p> essa é confirmação de seus dados na sua conta do moodle(UFSC) e no polvo (UDESC), <p>att <b>Aldair</b></p>',
      //   attachment: [
      //     { id: '29019230', name: 'tabela.xml' },
      //     { id: '39019230', name: 'tabela2.xml' },
      //   ],
      // },
    ],
    selectedMessage: {},
  }),
  computed: {
    ...mapState({
      actionsMap: (state) => state.user.mappedActions,
    }),
  },
  watch: {},
  async created() {
    await this.readUserSentMessages()
    await this.readAllMessagesRead()
    await this.readMessagesNotRead()
    this.mergeMessages() // junta as msgs não lidas com as lidas na array messages
  },
  methods: {
    //INICIO INTEGRAÇÃO BACKEND

    // mostra msgs enviadas pelo usuário
    async readUserSentMessages() {
      this.loading = true
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('directMessageCreate').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await DirectMessage.readUserSentMessage(entityId, actionId)
        if (ret.success) {
          let arrayToOrganize = ret.data
          let msgs = this.organizeMsg(arrayToOrganize, 'sent')
          this.showAllSentMessages = msgs
          if (this.viewSentMessages) this.messages = this.showAllSentMessages
          this.$store.commit('user/UPDATE_LOADING', false)
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.loading = false
      }
    },
    // carrega msg recebidas pelo usuário
    async readAllMessagesRead() {
      this.loading = true
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('directMessageRead').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await DirectMessage.readAllMessages(entityId, actionId)
        if (ret.success) {
          let arrayToOrganize = ret.data.emails
          let msgs = this.organizeMsg(arrayToOrganize, 'read')
          this.showAllMessages = msgs
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.loading = false
      }
    },

    //carrega msgs não lidas pelo usuário
    async readMessagesNotRead() {
      this.loading = true
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('directMessageRead').id
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await DirectMessage.readAllNewMessages(entityId, actionId)

        if (ret.success) {
          let arrayToOrganize = ret.data.emails
          let msgs = this.organizeMsg(arrayToOrganize, 'notRead')

          this.showAllMessagesNotRead = msgs
          if (this.viewAllMessagesNotRead) this.messages = this.showAllMessagesNotRead
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
        this.loading = false
      }
    },
    //marca como lido uma msg que ainda não foi lida
    async markAsRead(item) {
      if (!this.viewSentMessages) {
        const routedEntity = await this.$getItem('routedEntity')
        const entityId = routedEntity.id
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('directMessageRead').id
        const msgId = { mailId: item.id }
        try {
          this.$store.commit('user/UPDATE_LOADING', true)
          let ret = await DirectMessage.updateReadMessage(entityId, actionId, msgId)
          if (ret.success) {
            this.selectedMessage = item
            this.openDialogRead = true
            this.showAllMessagesNotRead.forEach((msg) => {
              if (msg.id == item.id) {
                Object.assign(msg, { msgRead: true })
                this.refreshLenghtNotRead++
                return
              }
            })
          }
        } catch (e) {
          console.log(e)
        } finally {
          this.$store.commit('user/UPDATE_LOADING', false)
        }
      } else {
        this.selectedMessage = item
        this.openDialogRead = true
      }
    },
    //FIM INTEGRAÇÃO BACKEND
    resetDialogInfo() {
      this.$store.commit('user/UPDATE_CLOSE_DIALOG', true)
    },

    teste() {
      console.log('clicou fora rsrsrsrs')
    },

    //organiza msgs objeto para o frontend; read -> false or true
    organizeMsg(arrayData, type) {
      let msgs = []

      arrayData.forEach((msg) => {
        let email

        if (type == 'read' || type == 'notRead') {
          email = {
            id: msg.id,
            msgRead: type == 'read' ? true : false,
            sender: `${msg.sendBy.name} ${msg.sendBy.surname}`,
            senderId: msg.sendBy.id,
            senderEmail: msg.sendBy.email,
            data: msg.sendDate,
            subject: msg.title,
            msgPreview: this.stripHtml(msg.subject.message),
            msg: msg.subject.message,
            attachment: [],
          }
        } else {
          email = {
            id: msg.id,
            msgRead: type == 'read' ? true : false,
            sendTo: msg.sendTo,
            data: msg.sendDate,
            subject: msg.title,
            msgPreview: this.stripHtml(msg.subject.message),
            msg: msg.subject.message,
            attachment: [],
          }
        }

        //checa se tem Attachments
        const attachmentCheck = msg.subject.attachments

        if (attachmentCheck && attachmentCheck.length > 0) {
          attachmentCheck.forEach((attachment, index) => {
            let attach = {
              id: Math.floor(Math.random() * 100000000000000000),
              name: `Anexo${attachment.substring(attachment.length - 4, attachment.length)}`,
            }
            email.attachment.push(attach)
          })
        }
        // fim checa attachment

        msgs.push(email)
      })
      return msgs.reverse()
    },

    // junta msgs não lidas + msgs lidas para ter todas msgs do usuário
    mergeMessages() {
      let msgNotRead = this.showAllMessagesNotRead
      let msgRead = this.showAllMessages
      let allMsg = msgNotRead.concat(msgRead)
      this.allMsgLength = allMsg.length

      /* organizar por data.
      use slice() to copy the array and not just make a reference*/

      let byDate = allMsg.slice(0)
      byDate.sort((a, b) => {
        return b.data - a.data
      })

      this.messages = byDate
    },

    // atualiza após enviar
    async refreshAfterSend() {
      await this.readAllMessagesRead()
      await this.readMessagesNotRead()
      await this.readUserSentMessages()

      if (this.viewAllMessages) this.mergeMessages()
    },

    // navegação ver todas/não lidas
    async refresh() {
      if (this.viewAllMessagesNotRead) {
        await this.readMessagesNotRead()
        this.messages = this.showAllMessagesNotRead
        this.refreshLenghtNotRead = 0
      }
      if (this.viewAllMessages) {
        await this.readAllMessagesRead()
        await this.readMessagesNotRead()
        this.mergeMessages()
        this.refreshLenghtNotRead = 0
      }
      if (this.viewSentMessages) {
        this.$store.commit('user/UPDATE_LOADING', false)
        await this.readUserSentMessages()
        this.messages = this.showAllSentMessages
        this.refreshLenghtNotRead = 0
      }
    },

    async handleShowAllMessages() {
      this.viewAllMessagesNotRead = false
      this.viewAllMessages = true
      this.viewSentMessages = false
      this.refresh()
    },
    async handleShowAllMessagesNotRead() {
      this.viewAllMessages = false
      this.viewAllMessagesNotRead = true
      this.viewSentMessages = false
      this.refresh()
    },
    async handleShowAllMessagesSent() {
      this.viewAllMessages = false
      this.viewAllMessagesNotRead = false
      this.viewSentMessages = true
      this.refresh()
    },
    // fim navegação ver todas/não lidas

    //métodos para nova mensagem
    openNewMessageDialog() {
      this.openDialogNewMessage = true
    },
    closeNewMessageDialog() {
      this.openDialogNewMessage = false
    },
    closeDialog() {
      console.log('executou o método #closeDialog()')
      this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      this.openDialogNewMessage = false
    },
    //fim métodos nova mensagem

    //msg
    stripHtml(html) {
      let content = html
      let check = content.indexOf('<br>')
      if (check != -1) content = content.substring(0, check)
      var tmp = document.implementation.createHTMLDocument('New').body
      tmp.innerHTML = content
      return tmp.textContent || tmp.innerText || ''
    },
    //compara datas
    compareDate(timestamp) {
      return Utils.compareDate(timestamp)
    },
    async openMsg(item) {
      if (item.msgRead == false) {
        console.log(
          `Abre mensagem de id: ${item.id}\nEla foi marcada como lida e não aparecerá mais nas mensagens "Não Lidas"`
        )
        await this.markAsRead(item)
      } else {
        this.selectedMessage = item
        this.openDialogRead = true
      }
    },
    closeMsg() {
      this.openDialogRead = false
    },
    downloadAttachment(attachment) {
      console.log(`inicia o download de id: ${attachment}`)
    },
    //fim msg
  },
}
</script>

<style>
.emailStyle > .v-data-table tbody tr:hover:not(.v-data-table__expanded__content) {
  cursor: pointer !important;
}
.msgHeader > a {
  margin-right: 16px;
  color: #424242;
}

.msgHeader > a:hover {
  margin-right: 16px;
  color: #2a0845;
}

.navDirectMessageOption > .v-btn:hover {
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.noMsg {
  font-size: 1rem;
  min-height: 100px;
  text-align: center;
}
.noMsg > b {
  padding-left: 4px;
  padding-right: 4px;
}

.toolBar > .v-btn:hover{
  background: #e8e8e8 !important;
  color: #2a0845 !important;
}

.toolBar {
  /* background-color: blue; */
  padding-top: 15px;
  padding-left: 17px;
  width: 100%;
  display: flex;
  align-items: center;
  justify-content: start;
  flex-wrap: wrap;
  gap: 5px
  
}


</style>
